"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __commonJS = (cb, mod) => function __require() {
  return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// ../convostack-shared/dist/index.js
var require_dist = __commonJS({
  "../convostack-shared/dist/index.js"(exports, module2) {
    "use strict";
    var __create2 = Object.create;
    var __defProp2 = Object.defineProperty;
    var __getOwnPropDesc2 = Object.getOwnPropertyDescriptor;
    var __getOwnPropNames2 = Object.getOwnPropertyNames;
    var __getProtoOf2 = Object.getPrototypeOf;
    var __hasOwnProp2 = Object.prototype.hasOwnProperty;
    var __export2 = (target, all) => {
      for (var name in all)
        __defProp2(target, name, { get: all[name], enumerable: true });
    };
    var __copyProps2 = (to, from, except, desc) => {
      if (from && typeof from === "object" || typeof from === "function") {
        for (let key of __getOwnPropNames2(from))
          if (!__hasOwnProp2.call(to, key) && key !== except)
            __defProp2(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc2(from, key)) || desc.enumerable });
      }
      return to;
    };
    var __toESM2 = (mod, isNodeMode, target) => (target = mod != null ? __create2(__getProtoOf2(mod)) : {}, __copyProps2(
      // If the importer is in node compatibility mode or this is not an ESM
      // file that has been converted to a CommonJS file using a Babel-
      // compatible transform (i.e. "__esModule" has not been set), then set
      // "default" to the CommonJS "module.exports" for node compatibility.
      isNodeMode || !mod || !mod.__esModule ? __defProp2(target, "default", { value: mod, enumerable: true }) : target,
      mod
    ));
    var __toCommonJS2 = (mod) => __copyProps2(__defProp2({}, "__esModule", { value: true }), mod);
    var src_exports2 = {};
    __export2(src_exports2, {
      AI_ROLE: () => AI_ROLE,
      CONVERSATION_EVENT_KIND_CONVERSATION_METADATA: () => CONVERSATION_EVENT_KIND_CONVERSATION_METADATA,
      CONVERSATION_EVENT_KIND_MESSAGE: () => CONVERSATION_EVENT_KIND_MESSAGE,
      CONVERSATION_EVENT_KIND_MESSAGE_PART: () => CONVERSATION_EVENT_KIND_MESSAGE_PART,
      HUMAN_ROLE: () => HUMAN_ROLE,
      addSecondsToDate: () => addSecondsToDate2,
      generateRandomID: () => generateRandomID2,
      unixTimestamp: () => unixTimestamp2
    });
    module2.exports = __toCommonJS2(src_exports2);
    var CONVERSATION_EVENT_KIND_MESSAGE = "message";
    var CONVERSATION_EVENT_KIND_MESSAGE_PART = "message_part";
    var CONVERSATION_EVENT_KIND_CONVERSATION_METADATA = "conversation_metadata";
    var AI_ROLE = "AI";
    var HUMAN_ROLE = "Human";
    var import_crypto = __toESM2(require("crypto"));
    var generateRandomID2 = (length) => {
      return import_crypto.default.randomBytes(length).toString("hex");
    };
    var unixTimestamp2 = (date) => {
      if (!date) {
        date = /* @__PURE__ */ new Date();
      }
      return Math.floor(date.getTime() / 1e3);
    };
    var addSecondsToDate2 = (date, seconds) => {
      const newUnixTimestamp = unixTimestamp2(date) + seconds;
      return new Date(newUnixTimestamp * 1e3);
    };
  }
});

// src/index.ts
var src_exports = {};
__export(src_exports, {
  AuthJWT: () => AuthJWT
});
module.exports = __toCommonJS(src_exports);
var crypto = __toESM(require("crypto"));
var import_shared = __toESM(require_dist());
var import_jsonwebtoken = require("jsonwebtoken");
var AuthJWT = class {
  constructor(storage, options) {
    this.storage = storage;
    this.options = options;
    if (!this.options.jwtSecret || this.options.jwtSecret.length < 32) {
      throw new Error("AuthJWT 'jwtSecret' option must be at least 32 characters in length");
    }
    if (this.options.requireUserVerificationHash && (!this.options.userDataVerificationSecret || this.options.userDataVerificationSecret.length < 32)) {
      throw new Error("AuthJWT 'userDataVerificationSecret' option must be at least 32 characters in length");
    }
    if (!this.options.accessTokenTTL || this.options.accessTokenTTL < 1) {
      this.options.accessTokenTTL = 60 * 15;
    }
    if (!this.options.refreshTokenTTL || this.options.refreshTokenTTL < 1) {
      this.options.refreshTokenTTL = 60 * 60 * 24 * 7;
    }
  }
  async validateTokenFromAuthorizationValueIfProvided(authHeaderValue) {
    if (!authHeaderValue) {
      return {
        user: null
      };
    }
    let token = "";
    if (authHeaderValue.startsWith("Bearer ")) {
      token = authHeaderValue.substring(7, authHeaderValue.length);
    } else {
      throw new Error("Access denied. Invalid Authorization header.");
    }
    try {
      const decoded = await this.validateAccessToken(token);
      const user = await this.storage.findUser({ id: decoded.userId });
      if (!user || user.id != decoded.userId) {
        throw new Error("Access denied. Invalid token.");
      }
      return {
        user
      };
    } catch (err) {
      throw new Error("Access denied. Invalid token.");
    }
  }
  async getGQLAuthContextHTTP(req) {
    return await this.validateTokenFromAuthorizationValueIfProvided(req.headers["authorization"]);
  }
  async getGQLAuthContextWS(connectionParams) {
    return await this.validateTokenFromAuthorizationValueIfProvided(connectionParams["Authorization"]);
  }
  async login(req, {
    email,
    externalId,
    name,
    anonymousId,
    hash
  }) {
    let user;
    if (typeof email === "string") {
      email = email.trim();
    }
    if (typeof name === "string") {
      name = name.trim();
    }
    if (typeof externalId === "string") {
      externalId = externalId.trim();
    }
    if (!email) {
      email = null;
    }
    if (!name) {
      name = null;
    }
    if (!externalId) {
      externalId = null;
    }
    if (!anonymousId) {
      anonymousId = null;
    }
    if ((email || externalId) && anonymousId) {
      throw new Error("anonymous users cannot have email or external id");
    }
    if (email && !this.isValidEmail(email)) {
      throw new Error("provided email is not a valid email");
    }
    const isAnon = !email && !externalId || anonymousId;
    if (!this.options.allowAnonUsers && isAnon) {
      throw new Error("anonymous users are not allowed");
    }
    if (!isAnon && this.options.requireUserVerificationHash) {
      const correctHash = this.generateVerificationHash(this.options.userDataVerificationSecret, externalId, email, name);
      if (correctHash !== hash) {
        throw new Error("user data verification hash is invalid");
      }
    }
    if (anonymousId) {
      user = await this.storage.findUser({
        anonymousId
      });
    } else if (externalId) {
      user = await this.storage.findUser({
        externalId
      });
      if (!user) {
        user = await this.storage.createUser({
          name,
          email,
          externalId
        });
      } else {
        if (user.name != name || user.email != email) {
          user = await this.storage.updateUser(
            user.id,
            {
              name,
              email
            }
          );
        }
      }
    } else if (email) {
      user = await this.storage.findUser({
        email
      });
      if (!user) {
        user = await this.storage.createUser({
          name,
          email
        });
      } else {
        if (user.name != name) {
          user = await this.storage.updateUser(
            user.id,
            {
              name
            }
          );
        }
      }
    } else {
      user = await this.storage.createUser({
        anonymousId: (0, import_shared.generateRandomID)(64)
      });
    }
    if (!user) {
      throw new Error("Login failed");
    }
    const accessToken = this.generateAccessToken(user);
    const refreshToken = this.generateRefreshToken(user);
    return {
      accessToken,
      anonymousId: user.anonymousId,
      refreshToken,
      anonymous: !!user.anonymousId,
      email: user.email,
      name: user.name,
      userId: user.id
    };
  }
  async refresh(req, params) {
    const tknPayload = await this.validateRefreshToken(params.refreshToken);
    const user = await this.storage.findUser({
      id: tknPayload.userId
    });
    if (!user) {
      throw new Error("Login failed");
    }
    const accessToken = this.generateAccessToken(user);
    const refreshToken = this.generateRefreshToken(user);
    return {
      accessToken,
      anonymousId: user.anonymousId,
      refreshToken,
      anonymous: !!user.anonymousId,
      email: user.email,
      name: user.name,
      userId: user.id
    };
  }
  sign(secret, ttlSecs, payload) {
    const signOptions = {
      algorithm: "HS256",
      expiresIn: ttlSecs
    };
    return (0, import_jsonwebtoken.sign)(payload, secret, signOptions);
  }
  validate(secret, token, kind) {
    const verifyOptions = {
      algorithms: ["HS256"]
    };
    return new Promise((resolve, reject) => {
      (0, import_jsonwebtoken.verify)(token, secret, verifyOptions, (error, decoded) => {
        if (error) {
          return reject(error);
        }
        if (!decoded) {
          return reject(new Error("invalid jwt payload on validation"));
        }
        if (decoded["kind"] !== kind) {
          return reject(new Error("invalid token kind"));
        }
        resolve(decoded);
      });
    });
  }
  generateAccessToken(user) {
    const payload = {
      userId: user.id,
      email: user.email,
      kind: "access"
    };
    const tkn = this.sign(this.options.jwtSecret, this.options.accessTokenTTL, payload);
    return {
      token: tkn,
      expAt: (0, import_shared.unixTimestamp)(
        (0, import_shared.addSecondsToDate)(
          /* @__PURE__ */ new Date(),
          this.options.accessTokenTTL
        )
      )
    };
  }
  generateRefreshToken(user) {
    const payload = {
      userId: user.id,
      email: user.email,
      kind: "refresh"
    };
    const tkn = this.sign(this.options.jwtSecret, this.options.refreshTokenTTL, payload);
    return {
      token: tkn,
      expAt: (0, import_shared.unixTimestamp)(
        (0, import_shared.addSecondsToDate)(
          /* @__PURE__ */ new Date(),
          this.options.refreshTokenTTL
        )
      )
    };
  }
  validateRefreshToken(token) {
    try {
      return this.validate(this.options.jwtSecret, token, "refresh");
    } catch (err) {
      throw new Error("Invalid refresh token");
    }
  }
  validateAccessToken(token) {
    try {
      return this.validate(this.options.jwtSecret, token, "access");
    } catch (err) {
      throw new Error("Invalid access token");
    }
  }
  generateVerificationHash(hashSecret, userId, email, name) {
    if (!hashSecret) {
      throw new Error("user data hash verification failed because no secret was provided");
    }
    const hmac = crypto.createHmac("sha256", hashSecret);
    const payload = `userId:${userId ? userId : "null"}
email:${email ? email : "null"}
${name ? name : "null"}`;
    hmac.update(payload);
    return hmac.digest("hex");
  }
  isValidEmail(email) {
    const emailRegex = /^[\w-]+(\.[\w-]+)*@([\w-]+\.)+[a-zA-Z]{2,7}$/;
    return emailRegex.test(email);
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  AuthJWT
});
